osl::rating::Chase Class Reference

`#include <feature.h>`

Inheritance diagram for osl::rating::Chase:

## Public Types

enum | OpponentType { CAPTURE , DROP , ESCAPE , OTHER }

## Public Member Functions

| Chase (Ptype s, Ptype t, bool d, OpponentType o)
bool | match (const NumEffectState &state, Move move, const RatingEnv &env) const
Public Member Functions inherited from osl::rating::Feature
| Feature (const std::string &name)
virtual | ~Feature ()
virtual bool | effectiveInCheck () const
const std::string & | name () const

## Static Public Member Functions

static const std::string | name (Ptype, Ptype, bool, OpponentType)

## Private Attributes

Ptype | self
Ptype | target
bool | drop
OpponentType | opponent_type

## Detailed Description

Definition at line 139 of file rating/feature.h.

## Member Enumeration Documentation

## OpponentType

enum osl::rating::Chase::OpponentType

Enumerator
CAPTURE |
DROP |
ESCAPE |
OTHER |

Definition at line 142 of file rating/feature.h.

## Constructor & Destructor Documentation

## Chase()

osl::rating::Chase::Chase | ( | Ptype | s,
|  | Ptype | t,
|  | bool | d,
|  | OpponentType | o )

inline

Definition at line 148 of file rating/feature.h.

References drop, osl::rating::Feature::Feature(), name(), opponent_type, self, and target.

## Member Function Documentation

## match()

bool osl::rating::Chase::match | ( | const NumEffectState & | state,
|  | Move | move,
|  | const RatingEnv & | env ) const

inline virtual

Implements osl::rating::Feature.

Definition at line 150 of file rating/feature.h.

References CAPTURE, osl::Move::capturePtype(), DROP, drop, ESCAPE, osl::Move::from(), osl::NumEffectState::hasEffectAt(), osl::NumEffectState::hasEffectIf(), osl::rating::RatingEnv::history, osl::Move::isDrop(), osl::Move::isNormal(), osl::container::MoveStack::lastMove(), opponent_type, OTHER, osl::Move::ptype(), osl::PTYPE_EMPTY, osl::Move::ptypeO(), self, target, osl::Move::to(), and osl::SimpleState::turn().

## name()

const std::string osl::rating::Chase::name | ( | Ptype | self,
|  | Ptype | target,
|  | bool | drop,
|  | OpponentType | opponent_type )

static

Definition at line 138 of file feature.cc.

References CAPTURE, DROP, drop, opponent_type, osl::Ptype_Table, self, and target.

Referenced by Chase().

## Member Data Documentation

## drop

bool osl::rating::Chase::drop

private

Definition at line 145 of file rating/feature.h.

Referenced by Chase(), match(), and name().

## opponent_type

OpponentType osl::rating::Chase::opponent_type

private

Definition at line 146 of file rating/feature.h.

Referenced by Chase(), match(), and name().

## self

Ptype osl::rating::Chase::self

private

Definition at line 144 of file rating/feature.h.

Referenced by Chase(), match(), and name().

## target

Ptype osl::rating::Chase::target

private

Definition at line 144 of file rating/feature.h.

Referenced by Chase(), match(), and name().

The documentation for this class was generated from the following files:

- rating/feature.h
- feature.cc